Index: apps/settings_list.c
===================================================================
RCS file: apps/settings_list.c
diff -N apps/settings_list.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ apps/settings_list.c	15 Nov 2006 08:00:25 -0000
@@ -0,0 +1,956 @@
+/***************************************************************************
+ *             __________               __   ___.
+ *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
+ *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
+ *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
+ *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
+ *                     \/            \/     \/    \/            \/
+ * $Id:  $
+ *
+ * Copyright (C) 2006 Jonathan Gordon
+ *
+ * All files in this archive are subject to the GNU General Public License.
+ * See the file COPYING in the source tree root for full license agreement.
+ *
+ * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
+ * KIND, either express or implied.
+ *
+ ****************************************************************************/
+#include <stdbool.h>
+#include <stdlib.h>
+#include <stddef.h>
+#include "config.h"
+#include "lang.h"
+#include "settings.h"
+#include "sound.h"
+#include "stdio.h"
+#include "lcd.h"
+#include "talk.h"
+#include "settings_list.h"
+#include "splash.h"
+#include "kernel.h"
+
+/* files needed for the variaous option callbacks*/
+#include "playback.h"
+#include "eq_menu.h"
+#include "statusbar.h"
+#include "settings.h"
+
+/* helpful macros for hopefully this file only! */
+#define GS(a) &global_settings.a
+#define _INT(...) {.values = (int[]){__VA_ARGS__}}
+#define _STR(...) {.strings = (char*[]){__VA_ARGS__}}
+#define _TALKID(...) (int[]){__VA_ARGS__}
+#define _REALVAL(s,v) (void*)s,(void*)v
+
+#define SOUND_ITEM(flags,var,name,setting, cfg)                       \
+    {flags|F_T_INT|F_T_SOUND, GS(var), {0}, {.cfg_lang_id = name}, 1, \
+    _INT(setting), NULL, NULL, cfg }
+    
+#define BOOL_ITEM(flags,var,name,default,cb, cfg)                     \
+    {flags|F_T_BOOL, GS(var), {.bool_ = default},                     \
+    {.cfg_lang_id = name}, 0,{NULL}, NULL, cb, cfg }
+    
+#define INT_ITEM(flags,var,name,default,min,max,step,unit,            \
+    cb,formatter, cfg) {flags|F_T_INT, GS(var), {.int_ = default},    \
+    {name}, 3,_INT(min,max,step,(int)formatter), _TALKID(unit),       \
+    cb, cfg }
+    
+#define SYSTEM_ITEM(type,var,default, cb)                             \
+    {type|F_SYSTEMSETTING|F_LANG_IS_STRING, GS(var), {default},       \
+    {.cfg_string = #var}, 0,{NULL}, NULL, cb ,NULL}
+    
+#define CHOICE_ITEM(flags,var,name, cfg,default, cb,count,...)        \
+    {flags|F_T_INT|F_T_CHOICE, GS(var), {.int_ = default}, {name},    \
+    count, _INT(__VA_ARGS__),NULL, cb, cfg }
+#define STRINGCHOICE_ITEM(flags,var,name,cfg,default,count,           \
+        Strings,talks, cb) {flags|F_T_INT|F_T_CHOICE|F_LANG_STRING,   \
+        GS(var), {.int_ = default}, {name},count, Strings, talks,     \
+        cb, cfg }
+#define STRING_ITEM(flags,var,name,default,cb)                        \
+    {flags|F_T_CHARPTR|F_LANG_IS_STRING, GS(var),                     \
+    {.charptr = default}, {.cfg_string = name},0, {NULL}, NULL,       \
+    cb, name}
+
+
+#if defined(CONFIG_BACKLIGHT)
+/* use me when realvalues are impleneted for backlight and such
+static const char *backlight_times_strings[] = {
+        _REALVAL("on",-1),_REALVAL("off",0),_REALVAL("1",1),_REALVAL("2",2),
+        _REALVAL("3",3),_REALVAL("4",4),_REALVAL("5",5),_REALVAL("6",6),
+        _REALVAL("7",7),_REALVAL("8",8),_REALVAL("9",9),_REALVAL("10",10),
+        _REALVAL("15",15),_REALVAL("20",20),_REALVAL("25",25),_REALVAL("30",30),
+        _REALVAL("45",45),_REALVAL("60",60),_REALVAL("90",90)};
+*/
+static const char *backlight_times_strings[] = {
+                      "off","on","1","2","3","4","5","6","7","8",
+                      "9","10","15","20","25","30","45","60","90"};
+static const int  backlight_times_talks[] =  {
+                LANG_OFF,LANG_ON,TALK_ID(1,UNIT_SEC),TALK_ID(2,UNIT_SEC),
+                TALK_ID(3,UNIT_SEC),TALK_ID(4,UNIT_SEC),TALK_ID(5,UNIT_SEC),
+                TALK_ID(6,UNIT_SEC),TALK_ID(7,UNIT_SEC),TALK_ID(8,UNIT_SEC),
+                TALK_ID(9,UNIT_SEC),TALK_ID(10,UNIT_SEC),TALK_ID(15,UNIT_SEC),
+                TALK_ID(20,UNIT_SEC),TALK_ID(25,UNIT_SEC),TALK_ID(30,UNIT_SEC),
+                TALK_ID(45,UNIT_SEC),TALK_ID(60,UNIT_SEC),TALK_ID(90,UNIT_SEC)};
+#endif
+#ifdef HAVE_RECORDING
+/* keep synchronous to trig_durations and
+   trigger_times in settings_apply_trigger */
+static const char *trig_durations_strings[] = 
+    {"0s","1s","2s","5s","10s","15s","20s",
+    "25s","30s","1min","2min","5min","10min"};
+static const int  trig_durations_talks[] =  {
+    TALK_ID(0,UNIT_SEC),TALK_ID(1,UNIT_SEC),
+    TALK_ID(2,UNIT_SEC),TALK_ID(5,UNIT_SEC),
+    TALK_ID(10,UNIT_SEC),TALK_ID(15,UNIT_SEC),
+    TALK_ID(20,UNIT_SEC),TALK_ID(25,UNIT_SEC),
+    TALK_ID(30,UNIT_SEC),TALK_ID(1,UNIT_MIN),
+    TALK_ID(2,UNIT_MIN),TALK_ID(5,UNIT_MIN),TALK_ID(10,UNIT_MIN)};
+#endif
+
+/* callback functions needed for the settings */
+#if CONFIG_CODEC == SWCODEC
+    /* scrossfeed */
+static void crossfeed_format(char* buffer, int buffer_size, int value,
+                                 const char* unit)
+{
+    snprintf(buffer, buffer_size, "%s%d.%d %s", value == 0 ? " " : "-",
+             value / 10, value % 10, unit);
+}
+#endif /* CONFIG_CODEC == SWCODEC */
+#if (CONFIG_CODEC == MAS3587F) || (CONFIG_CODEC == MAS3539F)
+static void set_mdb_enable(bool value)
+{
+    sound_set_mdb_enable((int)value);
+}
+#endif
+#include "debug.h"
+#ifdef HAVE_DIRCACHE
+static void dircache_cb(bool value)
+{
+    DEBUGF("hi!\n");
+    (void)value;
+    if (!dircache_is_enabled() && global_settings.dircache)
+        gui_syncsplash(HZ, true, str(LANG_DIRCACHE_REBOOT));
+}
+#endif /* HAVE_DIRCACHE */
+
+
+
+
+const struct settings_list  settings[] = {
+    /* sound */
+    SOUND_ITEM(0,volume,LANG_VOLUME,SOUND_VOLUME,"volume"),
+    SOUND_ITEM(0,balance,LANG_BALANCE,SOUND_BALANCE,"balance"),
+    SOUND_ITEM(0,bass,LANG_BASS,SOUND_BASS,"bass"),
+    SOUND_ITEM(0,treble,LANG_TREBLE,SOUND_TREBLE,"treble"),
+#if (CONFIG_CODEC == MAS3587F) || (CONFIG_CODEC == MAS3539F)
+    SOUND_ITEM(0,loudness,LANG_LOUDNESS,SOUND_LOUDNESS,"loudness"),
+    STRINGCHOICE_ITEM(0,avc,LANG_AUTOVOL,"auto volume",0,5,
+                      _STR("off","20ms","2","4","8"),
+                      _TALKID(LANG_OFF,TALK_ID(20, UNIT_MS),TALK_ID(2, UNIT_SEC),
+                              TALK_ID(4, UNIT_SEC),TALK_ID(8, UNIT_SEC)), NULL),
+    BOOL_ITEM(0,superbass,LANG_SUPERBASS,false, NULL,"superbass"),
+#endif
+    CHOICE_ITEM(0,channel_config,LANG_CHANNEL,
+                "channels,stereo,mono,custom,mono left,mono right,karaoke",
+                0, NULL,6,
+                LANG_CHANNEL_STEREO,LANG_CHANNEL_MONO,
+                LANG_CHANNEL_CUSTOM,LANG_CHANNEL_LEFT,
+                LANG_CHANNEL_RIGHT,LANG_CHANNEL_KARAOKE),
+    SOUND_ITEM(0,stereo_width,LANG_STEREO_WIDTH,SOUND_STEREO_WIDTH,"stereo width"),
+    
+    /* playback */
+    BOOL_ITEM(0,resume,LANG_RESUME,false, NULL, "resume"),
+    BOOL_ITEM(0,playlist_shuffle,LANG_SHUFFLE,false, NULL, "shuffle"),
+    SYSTEM_ITEM(F_T_INT,resume_index,-1, NULL),
+    SYSTEM_ITEM(F_T_INT,resume_first_index,0, NULL),
+    SYSTEM_ITEM(F_T_INT,resume_offset,-1, NULL),
+    SYSTEM_ITEM(F_T_INT,resume_seed,-1, NULL),
+    CHOICE_ITEM(0,repeat_mode,LANG_REPEAT, "repeat,off,all,one,shuffle,ab",
+                REPEAT_ALL, NULL,NUM_REPEAT_MODES,
+        LANG_OFF,LANG_REPEAT_ALL,LANG_REPEAT_ONE,LANG_SHUFFLE,LANG_REPEAT_AB),
+    
+    /* LCD */
+#ifdef HAVE_LCD_CONTRAST
+    INT_ITEM(0,contrast,LANG_CONTRAST,DEFAULT_CONTRAST_SETTING,
+             MIN_CONTRAST_SETTING,MAX_CONTRAST_SETTING,1,UNIT_INT,
+             NULL, NULL, "contrast"),
+#endif
+#ifdef CONFIG_BACKLIGHT
+    STRINGCHOICE_ITEM(0,backlight_timeout,LANG_BACKLIGHT,
+                      "backlight timeout",
+                      6,sizeof(backlight_times_strings)/
+                              sizeof(*backlight_times_strings),
+                      {.strings = (char **)backlight_times_strings},
+                      (int*)backlight_times_talks, NULL),
+#ifdef CONFIG_CHARGING
+    STRINGCHOICE_ITEM(0,backlight_timeout_plugged,
+                      LANG_BACKLIGHT_ON_WHEN_CHARGING,
+                      "backlight timeout plugged",11,
+                  sizeof(backlight_times_strings)/
+                          sizeof(*backlight_times_strings),
+                  {.strings = (char **)backlight_times_strings},
+                  (int*)backlight_times_talks, NULL),
+#endif
+#endif /* CONFIG_BACKLIGHT */
+    
+    /* display */
+#ifdef HAVE_LCD_BITMAP
+    CHOICE_ITEM(0,invert,LANG_INVERT, "invert,off,on",
+                0, NULL,2,LANG_INVERT_LCD_NORMAL,LANG_INVERT_LCD_INVERSE),
+    BOOL_ITEM(0,flip_display,LANG_FLIP_DISPLAY,false, NULL, "flip display"),
+    BOOL_ITEM(0,invert_cursor,LANG_INVERT_CURSOR,true, NULL, "invert cursor"),
+    BOOL_ITEM(F_TEMPVARIABLE|F_THEMESETTING,statusbar,LANG_STATUS_BAR,true, NULL, "statusbar"),
+    BOOL_ITEM(0,scrollbar,LANG_SCROLL_BAR,true, NULL, "scrollbar"),
+#if CONFIG_KEYPAD == RECORDER_PAD
+    BOOL_ITEM(0,buttonbar,LANG_BUTTON_BAR,true, NULL, "buttonbar"),
+#endif
+    CHOICE_ITEM(0,volume_type,LANG_VOLUME_DISPLAY, "volume display,graphic,numeric",
+                0, NULL,2,LANG_DISPLAY_GRAPHIC,LANG_DISPLAY_NUMERIC),
+    CHOICE_ITEM(0,battery_display,LANG_BATTERY_DISPLAY,
+                "battery display,graphic,numeric",
+                0, NULL,2,LANG_DISPLAY_GRAPHIC,LANG_DISPLAY_NUMERIC),
+    CHOICE_ITEM(0,timeformat,LANG_TIMEFORMAT, 
+                "time format,24hour,12hour", 0, NULL,2,
+                LANG_24_HOUR_CLOCK,LANG_12_HOUR_CLOCK),
+#endif /* HAVE_LCD_BITMAP */
+    BOOL_ITEM(0,show_icons,LANG_SHOW_ICONS,true, NULL, "show icons"),
+    
+    /* system */
+    STRINGCHOICE_ITEM(0,poweroff,LANG_POWEROFF_IDLE,"idle poweroff",
+                      10,15,
+                      _STR("off","1","2","3","4","5","6","7",
+                           "8","9","10","15","30","45","60"),
+                      _TALKID(LANG_OFF,TALK_ID(1, UNIT_MIN),
+                              TALK_ID(2, UNIT_MIN),TALK_ID(3, UNIT_MIN),
+                              TALK_ID(4, UNIT_MIN),TALK_ID(5, UNIT_MIN),
+                              TALK_ID(6, UNIT_MIN),TALK_ID(7, UNIT_MIN),
+                              TALK_ID(8, UNIT_MIN),TALK_ID(9, UNIT_MIN),
+                              TALK_ID(10, UNIT_MIN),TALK_ID(15, UNIT_MIN),
+                              TALK_ID(30, UNIT_MIN),TALK_ID(45, UNIT_MIN),
+                              TALK_ID(60, UNIT_MIN)), NULL),
+    SYSTEM_ITEM(F_T_INT,runtime,0, NULL),
+    SYSTEM_ITEM(F_T_INT,topruntime,0, NULL),
+    INT_ITEM(0,max_files_in_playlist,LANG_MAX_FILES_IN_PLAYLIST,
+#if MEM > 1
+             10000,1000,20000,1000
+#else
+             1000,1000,10000,100
+#endif
+            ,UNIT_INT, NULL, NULL,"max files in playlist"),
+    INT_ITEM(0,max_files_in_dir,LANG_MAX_FILES_IN_DIR,
+#if MEM > 1
+             400,50,10000,50
+#else
+             200,50,10000,50
+#endif
+            ,UNIT_INT, NULL, NULL,"max files in dir"),
+
+    /* battery */
+#ifndef SIMULATOR
+    INT_ITEM(0,battery_capacity,LANG_BATTERY_CAPACITY,BATTERY_CAPACITY_DEFAULT,
+             BATTERY_CAPACITY_MIN,BATTERY_CAPACITY_MAX,BATTERY_CAPACITY_INC,
+             UNIT_INT, NULL, NULL,"battery capacity"),
+#ifdef CONFIG_CHARGING
+    BOOL_ITEM(0,car_adapter_mode,LANG_CAR_ADAPTER_MODE,false,
+              NULL,"car adapter mode"),
+#endif
+#if BATTERY_TYPES_COUNT > 1
+    CHOICE_ITEM(0,battery_type,LANG_BATTERY_TYPE,"battery type,alkaline,nimh",
+                0, NULL,2,LANG_BATTERY_TYPE_ALKALINE,LANG_BATTERY_TYPE_NIMH),
+#endif
+#endif
+#ifdef CONFIG_TUNER
+    /* tuner */
+    BOOL_ITEM(0,fm_force_mono,LANG_FM_MONO_MODE,false, NULL,"force fm mono"),
+    SYSTEM_ITEM(F_T_INT,last_frequency,0, NULL),
+    STRINGCHOICE_ITEM(0,fm_region,LANG_FM_REGION,"fm_region",
+                      0,4,
+                      _STR("eu","us","jp","kr"),
+                      NULL, NULL),
+#endif
+
+#ifdef HAVE_REMOTE_LCD
+    /* remote lcd */
+    INT_ITEM(0,remote_contrast,LANG_CONTRAST,42,
+                   MIN_CONTRAST_SETTING,MAX_CONTRAST_SETTING,1,UNIT_INT,
+                   NULL, NULL,"remote contrast"),
+    CHOICE_ITEM(0,remote_invert,LANG_INVERT, "remote invert,off,on",
+                0, NULL,2,LANG_INVERT_LCD_NORMAL,LANG_INVERT_LCD_INVERSE),
+    BOOL_ITEM(0,remote_flip_display,LANG_FLIP_DISPLAY,false, NULL,
+              "remote flip display"),
+    STRINGCHOICE_ITEM(0,remote_backlight_timeout,LANG_BACKLIGHT,
+                            "remote backlight timeout",
+                            6,sizeof(backlight_times_strings)/
+                                    sizeof(*backlight_times_strings),
+                      {.strings = (char **)backlight_times_strings},
+                      (int*)backlight_times_talks, NULL),
+#ifdef CONFIG_CHARGING
+    STRINGCHOICE_ITEM(0,remote_backlight_timeout_plugged,
+                      LANG_BACKLIGHT_ON_WHEN_CHARGING,
+                            "remote backlight timeout plugged",11,
+                      sizeof(backlight_times_strings)/
+                              sizeof(*backlight_times_strings),
+                      {.strings = (char **)backlight_times_strings},
+                      (int*)backlight_times_talks, NULL),
+#endif
+#ifdef HAVE_REMOTE_LCD_TICKING
+    BOOL_ITEM(0,remote_reduce_ticking,LANG_REDUCE_TICKING,false,
+              NULL, "remote reduce ticking"),
+#endif
+    BOOL_ITEM(0,remote_bl_filter_first_keypress,
+              LANG_BACKLIGHT_FILTER_FIRST_KEYPRESS,false, NULL,
+                    "backlight filters first remote keypress"),
+#endif /* HAVE_REMOTE_LCD */
+#ifdef CONFIG_BACKLIGHT
+    BOOL_ITEM(0,bl_filter_first_keypress,
+              LANG_BACKLIGHT_FILTER_FIRST_KEYPRESS,false, NULL,
+              "backlight filters first keypress"),
+#endif
+
+    /***************   end of old rtc table    ******************/
+    
+    /* display */
+#ifdef CONFIG_BACKLIGHT
+    BOOL_ITEM(0,caption_backlight,LANG_CAPTION_BACKLIGHT,false,
+              NULL, "caption backlight"),
+#endif
+#ifdef HAVE_REMOTE_LCD
+    BOOL_ITEM(0,remote_caption_backlight,LANG_CAPTION_BACKLIGHT,false,
+              NULL,"remote caption backlight"),
+#endif
+#ifdef HAVE_BACKLIGHT_BRIGHTNESS
+    INT_ITEM(0,brightness,LANG_CAPTION_BACKLIGHT,DEFAULT_BRIGHTNESS_SETTING,
+             MIN_BRIGHTNESS_SETTING,MAX_BRIGHTNESS_SETTING,1,UNIT_INT, NULL,
+             NULL, "brightness"),
+#endif
+#ifdef HAVE_BACKLIGHT_PWM_FADING
+    /* backlight fading */
+    STRINGCHOICE_ITEM(0,backlight_fade_in,LANG_BACKLIGHT_FADE_IN,
+                      "backlight fade in",1,4,
+                      _STR("off","500ms","1s","2s"),
+                      _TALKID(LANG_OFF,TALK_ID(500, UNIT_MS),
+                              TALK_ID(1, UNIT_SEC),TALK_ID(2, UNIT_SEC)), NULL),
+    STRINGCHOICE_ITEM(0,backlight_fade_out,LANG_BACKLIGHT_FADE_OUT,
+                      "backlight fade out",4,8,
+                    _STR("off","500ms","1s","2s","3s","4s","5s","10s"),
+                    _TALKID(LANG_OFF,TALK_ID(500, UNIT_MS),TALK_ID(1, UNIT_SEC),
+                            TALK_ID(2, UNIT_SEC),TALK_ID(3, UNIT_SEC),
+                            TALK_ID(4, UNIT_SEC),TALK_ID(5, UNIT_SEC),
+                            TALK_ID(10, UNIT_SEC)), NULL),
+#endif
+    INT_ITEM(0,scroll_speed,LANG_SCROLL_SPEED,9,0,15,1,UNIT_INT,
+             NULL, NULL, "scroll speed"),
+    INT_ITEM(0,scroll_delay,LANG_SCROLL_DELAY,6,0,250,1,UNIT_INT,
+             NULL, NULL, "scroll delay"),
+    INT_ITEM(0,bidir_limit,LANG_BIDIR_SCROLL,50,0,200,1,UNIT_INT,
+             NULL, NULL, "bidir limit"),
+#ifdef HAVE_REMOTE_LCD
+    INT_ITEM(0,remote_scroll_speed,LANG_SCROLL_SPEED,6,0,15,1,
+             UNIT_INT, NULL, NULL, "remote scroll speed"),
+    INT_ITEM(0,remote_scroll_step,LANG_SCROLL_STEP,9,1,160,1,
+             UNIT_INT, NULL, NULL, "remote scroll step"),
+    INT_ITEM(0,remote_scroll_delay,LANG_SCROLL_DELAY,100,0,250,1,
+             UNIT_INT, NULL, NULL, "remote scroll delay"),
+    INT_ITEM(0,remote_bidir_limit,LANG_BIDIR_SCROLL,50,0,200,1,
+             UNIT_INT, NULL, NULL, "remote bidir limit"),
+#endif
+#ifdef HAVE_LCD_BITMAP
+    BOOL_ITEM(0,offset_out_of_view,LANG_SCREEN_SCROLL_VIEW,
+              false, NULL, "Screen Scrolls Out Of View"),
+    INT_ITEM(0,scroll_step,LANG_SCROLL_STEP,6,1,LCD_WIDTH,1,
+             LANG_PIXELS, NULL, NULL, "scroll step"),
+    INT_ITEM(0,screen_scroll_step,LANG_SCREEN_SCROLL_STEP,16,1,
+             LCD_WIDTH,1,LANG_PIXELS, NULL, NULL, "screen scroll step"),
+#endif /* HAVE_LCD_BITMAP */
+#ifdef HAVE_LCD_CHARCELLS
+    STRINGCHOICE_ITEM(0,jump_scroll,LANG_JUMP_SCROLL, "jump scroll",0,6,
+                      _STR(ID2P(LANG_OFF),ID2P(LANG_ON),"2","3","4",
+                           ID2P(LANG_ALWAYS)),
+                      _TALKID(LANG_OFF,LANG_ON,TALK_ID(2, UNIT_INT),
+                              TALK_ID(3, UNIT_INT),
+                              TALK_ID(4, UNIT_INT),LANG_ALWAYS), NULL),
+    INT_ITEM(0,jump_scroll_delay,LANG_JUMP_SCROLL_DELAY,500,0,2500,100,
+             UNIT_MS, NULL, NULL, "jump scroll delay"),
+#endif
+    BOOL_ITEM(0,scroll_paginated,LANG_SCROLL_PAGINATED,false,
+              NULL, "scroll paginated"),
+#ifdef HAVE_LCD_COLOR
+{F_T_INT|F_STORERGB|F_LANG_IS_STRING|F_THEMESETTING, GS(fg_color), {LCD_DEFAULT_FG}, 
+    {.cfg_string = "foreground color"}, 0,{NULL}, NULL, NULL ,"foreground color"},
+{F_T_INT|F_STORERGB|F_LANG_IS_STRING|F_THEMESETTING, GS(bg_color), {LCD_DEFAULT_BG}, 
+    {.cfg_string = "background color"}, 0,{NULL}, NULL, NULL ,"background color"},
+#endif
+
+    /* more playback */
+    BOOL_ITEM(0,play_selected,LANG_PLAY_SELECTED,true, NULL, "play selected"),
+    BOOL_ITEM(0,party_mode,LANG_PARTY_MODE,false, NULL,"party mode"),
+    BOOL_ITEM(0,fade_on_stop,LANG_FADE_ON_STOP,true, NULL, "volume fade"),
+    INT_ITEM(0,ff_rewind_min_step,LANG_FFRW_STEP,FF_REWIND_1000,0,60,1,
+             UNIT_INT, NULL, NULL,
+             "scan min step"),
+    INT_ITEM(0,ff_rewind_accel,LANG_FFRW_ACCEL,3,0,60,1,UNIT_SEC,
+             NULL, NULL, "scan accel"),
+    STRINGCHOICE_ITEM(0,ff_rewind_accel,LANG_FFRW_ACCEL,
+                      "scan accel",3,16,
+                      _STR("off","2x/1s","2x/2s","2x/3s","2x/4s",
+                           "2x/5s","2x/6s","2x/7s",
+                           "2x/8s","2x/9s","2x/10s","2x/11s","2x/12s",
+                           "2x/13s","2x/14s","2x/15s"),
+                      _TALKID(LANG_OFF,TALK_ID(1, UNIT_INT),TALK_ID(2, UNIT_INT),
+                              TALK_ID(3, UNIT_INT),TALK_ID(4, UNIT_INT),
+                              TALK_ID(5, UNIT_INT),TALK_ID(6, UNIT_INT),
+                              TALK_ID(7, UNIT_INT),TALK_ID(8, UNIT_INT),
+                              TALK_ID(9, UNIT_INT),TALK_ID(10, UNIT_INT),
+                              TALK_ID(11, UNIT_INT),TALK_ID(12, UNIT_INT),
+                              TALK_ID(13, UNIT_INT),TALK_ID(14, UNIT_INT),
+                              TALK_ID(15, UNIT_INT)), NULL),
+#if CONFIG_CODEC == SWCODEC
+    STRINGCHOICE_ITEM(0,buffer_margin,LANG_MP3BUFFER_MARGIN,
+                      "antiskip",0,8,
+                      _STR("5s","15s","30s","1min","2min","3min","5min","10min"),
+                      _TALKID(TALK_ID(5, UNIT_SEC),TALK_ID(15, UNIT_SEC),
+                              TALK_ID(30, UNIT_SEC),TALK_ID(1, UNIT_MIN),
+                              TALK_ID(2, UNIT_MIN),TALK_ID(3, UNIT_MIN),
+                              TALK_ID(5, UNIT_MIN),TALK_ID(10, UNIT_MIN)), NULL),
+#else
+    INT_ITEM(0,buffer_margin,LANG_MP3BUFFER_MARGIN,1,0,7,1,UNIT_SEC,
+             NULL, NULL, "antiskip"),
+#endif
+
+    /* disk */
+#ifndef HAVE_MMC
+#ifdef HAVE_ATA_POWER_OFF
+    BOOL_ITEM(0,disk_poweroff,LANG_POWEROFF_IDLE,false, NULL, "disk poweroff"),
+#endif
+    INT_ITEM(0,disk_spindown,LANG_SPINDOWN,
+             5,1,254,3,UNIT_SEC, NULL, NULL, "disk spindown"),
+#endif /* !HAVE_MMC */
+
+    /* browser */
+    CHOICE_ITEM(0,dirfilter,LANG_FILTER,
+                "show files,all,supported,music,playlists,id3 database",
+                SHOW_SUPPORTED, NULL,5,
+                LANG_FILTER_ALL,LANG_FILTER_SUPPORTED,LANG_FILTER_MUSIC,
+                LANG_FILTER_PLAYLIST,LANG_FILTER_ID3DB),
+    BOOL_ITEM(0,sort_case,LANG_SORT_CASE,false, NULL, "sort case"),
+    BOOL_ITEM(0,browse_current,LANG_FOLLOW,false, NULL, "follow playlist"),
+    
+    /* playlist */
+    BOOL_ITEM(0,playlist_viewer_icons,LANG_SHOW_ICONS,true,
+              NULL, "playlist viewer icons"),
+    BOOL_ITEM(0,playlist_viewer_indices,LANG_SHOW_INDICES,true,
+              NULL, "playlist viewer indices"),
+    CHOICE_ITEM(0,playlist_viewer_track_display,LANG_TRACK_DISPLAY,
+                "playlist viewer track display,track name,full path", 0, NULL,2,
+                LANG_DISPLAY_TRACK_NAME_ONLY,LANG_DISPLAY_FULL_PATH),
+    CHOICE_ITEM(0,recursive_dir_insert,LANG_RECURSE_DIRECTORY,
+                "recursive directory insert,off,on,ask",
+                RECURSE_OFF, NULL,3,
+                LANG_ON,LANG_OFF,LANG_RESUME_SETTING_ASK),
+    
+    /* bookmarks */
+    CHOICE_ITEM(0,autocreatebookmark,LANG_BOOKMARK_SETTINGS_AUTOCREATE, 
+                "autocreate bookmarks,off,on,ask,recent only - on,recent only - ask",
+                BOOKMARK_NO, NULL,5,
+                LANG_OFF,LANG_ON,LANG_RESUME_SETTING_ASK,
+                LANG_BOOKMARK_SETTINGS_RECENT_ONLY_YES,
+                LANG_BOOKMARK_SETTINGS_RECENT_ONLY_ASK),
+    CHOICE_ITEM(0,autoloadbookmark,LANG_BOOKMARK_SETTINGS_AUTOLOAD,
+                "autoload bookmarks,off,on,ask",BOOKMARK_NO, NULL,3,
+                LANG_ON,LANG_OFF,LANG_RESUME_SETTING_ASK),
+    CHOICE_ITEM(0,usemrb,LANG_BOOKMARK_SETTINGS_MAINTAIN_RECENT_BOOKMARKS,
+                "use most-recent-bookmarks,off,on,unique only",BOOKMARK_NO, NULL,3,
+                LANG_OFF,LANG_ON,LANG_BOOKMARK_SETTINGS_UNIQUE_ONLY),
+    
+    /* peak meter */
+#ifdef HAVE_LCD_BITMAP
+    STRINGCHOICE_ITEM(0,peak_meter_clip_hold,LANG_PM_CLIP_HOLD,
+                      "peak meter clip hold",
+                      16,24,
+                _STR("on","1s","2s","3s","4s","5s","6s","7s","8s","9s","10s",
+                    "15s","20s","30s","45s","60s","90s","2min","3min","5min","10min",
+                    "20min","45min","90min"),
+                _TALKID(LANG_OFF,TALK_ID(1, UNIT_SEC),TALK_ID(2, UNIT_SEC),
+                        TALK_ID(3, UNIT_SEC),TALK_ID(4, UNIT_SEC),
+                        TALK_ID(5, UNIT_SEC),TALK_ID(6, UNIT_SEC),
+                        TALK_ID(7, UNIT_SEC),TALK_ID(8, UNIT_SEC),
+                        TALK_ID(9, UNIT_SEC),TALK_ID(10, UNIT_SEC),
+                        TALK_ID(15, UNIT_SEC),TALK_ID(20, UNIT_SEC),
+                        TALK_ID(30, UNIT_SEC),TALK_ID(45, UNIT_SEC),
+                        TALK_ID(60, UNIT_SEC),TALK_ID(90, UNIT_SEC),
+                        TALK_ID(2, UNIT_MIN),TALK_ID(3, UNIT_MIN),
+                        TALK_ID(5, UNIT_MIN),TALK_ID(10, UNIT_MIN),
+                        TALK_ID(20, UNIT_MIN),TALK_ID(45, UNIT_MIN),
+                        TALK_ID(90, UNIT_MIN)), NULL),
+    STRINGCHOICE_ITEM(0,peak_meter_hold,LANG_PM_PEAK_HOLD,
+                      "peak meter hold",
+                      3,18,
+                _STR("off","200ms","300ms","500ms","1s","2s","3s","4s",
+                    "5s","6s","7s","8s","9s","10s","15s","20s","30s","60s"),
+                _TALKID(LANG_OFF,TALK_ID(200, UNIT_MS),TALK_ID(300, UNIT_MS),
+                        TALK_ID(500, UNIT_MS),TALK_ID(1, UNIT_SEC),
+                        TALK_ID(2, UNIT_SEC),TALK_ID(3, UNIT_SEC),
+                        TALK_ID(4, UNIT_SEC),TALK_ID(5, UNIT_SEC),
+                        TALK_ID(6, UNIT_SEC),TALK_ID(7, UNIT_SEC),
+                        TALK_ID(8, UNIT_SEC),TALK_ID(9, UNIT_SEC),
+                        TALK_ID(10, UNIT_SEC),TALK_ID(15, UNIT_SEC),
+                        TALK_ID(20, UNIT_SEC),TALK_ID(30, UNIT_SEC),
+                        TALK_ID(60, UNIT_SEC)), NULL),
+    INT_ITEM(0,peak_meter_release,LANG_PM_RELEASE,8,0,126,1,
+             LANG_PM_UNITS_PER_READ, NULL, NULL, "peak meter release"),
+    BOOL_ITEM(0,peak_meter_dbfs,LANG_PM_DBFS,true, NULL, "peak meter dbfs"),
+    INT_ITEM(0,peak_meter_min,LANG_PM_MIN,60,0,100,1,UNIT_INT, NULL,
+             NULL, "peak meter min"),
+    INT_ITEM(0,peak_meter_max,LANG_PM_MAX,0,0,100,1,UNIT_INT, NULL,
+             NULL, "peak meter max"),
+#endif /* HAVE_LCD_BITMAP */
+#if (CONFIG_CODEC == MAS3587F) || (CONFIG_CODEC == MAS3539F)
+    SOUND_ITEM(0,mdb_strength,LANG_MDB_STRENGTH,
+               SOUND_MDB_STRENGTH, "mdb strength"),
+    SOUND_ITEM(0,mdb_harmonics,LANG_MDB_HARMONICS,
+               SOUND_MDB_HARMONICS, "mdb harmonics"),
+    SOUND_ITEM(0,mdb_center,LANG_MDB_CENTER,SOUND_MDB_CENTER, "mdb center"),
+    SOUND_ITEM(0,mdb_shape,LANG_MDB_SHAPE,SOUND_MDB_SHAPE, "mdb shape"),
+    BOOL_ITEM(0,mdb_enable,LANG_MDB_ENABLE, false,set_mdb_enable, "mdb enable"),
+#endif
+#if CONFIG_CODEC == MAS3507D
+    BOOL_ITEM(0,line_in,LANG_LINE_IN, false,NULL, "line in"),
+#endif
+
+    /* voice */
+    CHOICE_ITEM(0,talk_dir,LANG_VOICE_DIR, 
+                "talk dir,off,number,spell,hover",0, NULL,4,
+                LANG_OFF,LANG_VOICE_NUMBER,LANG_VOICE_SPELL,LANG_VOICE_DIR_HOVER),
+    CHOICE_ITEM(0,talk_file,LANG_VOICE_FILE, 
+                "talk file,off,number,spell,hover",0, NULL,4,
+                LANG_OFF,LANG_VOICE_NUMBER,LANG_VOICE_SPELL,LANG_VOICE_DIR_HOVER),
+    BOOL_ITEM(F_TEMPVARIABLE,talk_menu,LANG_VOICE_MENU, false,NULL, "talk menu"),
+    
+    /* file sorting */
+    CHOICE_ITEM(0,sort_file,LANG_SORT_FILE,
+                "sort files,alpha,oldest,newest,type",0, NULL,4,
+                LANG_SORT_ALPHA,LANG_SORT_DATE,
+                LANG_SORT_DATE_REVERSE,LANG_SORT_TYPE),
+    CHOICE_ITEM(0,sort_dir,LANG_SORT_DIR, 
+                "sort dirs,alpha,oldest,newest",0, NULL,3,
+                LANG_SORT_ALPHA,LANG_SORT_DATE,LANG_SORT_DATE_REVERSE),
+/*    CHOICE_ITEM(0,id3_v1_first,LANG_ID3_ORDER, 
+                "id3 tag priority,v2-v1,v1-v2",0, mpeg_id3_options,2,
+                LANG_ID3_V1_FIRST,LANG_ID3_V2_FIRST),
+ */
+#ifdef HAVE_RECORDING
+    /* recording */
+    SYSTEM_ITEM(F_T_BOOL,recscreen_on,0, NULL),
+    BOOL_ITEM(0,rec_startup,LANG_RECORD_STARTUP, 
+              false,NULL, "rec screen on startup"),
+    STRINGCHOICE_ITEM(0,rec_timesplit,LANG_SPLIT_TIME,
+                      "rec timesplit", 0,16,
+                      _STR("off","00:05","00:10","00:15","00:30","01:00","01:14",
+                           "01:20","02:00","04:00","06:00","08:00",
+                           "10:00","12:00","18:00","24:00"),
+                      _TALKID(LANG_OFF,TALK_ID(5, UNIT_MIN),TALK_ID(10, UNIT_MIN),
+                              TALK_ID(15, UNIT_MIN),TALK_ID(30, UNIT_MIN),
+                              TALK_ID(60, UNIT_MIN),TALK_ID(72, UNIT_MIN),
+                              TALK_ID(80, UNIT_MIN),TALK_ID(2, UNIT_HOUR),
+                              TALK_ID(4, UNIT_HOUR),TALK_ID(6, UNIT_HOUR),
+                              TALK_ID(8, UNIT_HOUR),TALK_ID(10, UNIT_HOUR),
+                              TALK_ID(12, UNIT_HOUR),TALK_ID(18, UNIT_HOUR),
+                              TALK_ID(24, UNIT_HOUR)), NULL),
+    STRINGCHOICE_ITEM(0,rec_sizesplit,LANG_SPLIT_SIZE,
+                      "rec sizesplit",0,16,
+                    _STR("off","5MB","10MB","15MB","32MB","64MB","75MB",
+                            "100MB","128MB","256MB","512MB","650MB",
+                            "700MB","1GB","1.5GB","1.75GB"),
+                    _TALKID(LANG_OFF,TALK_ID(5, UNIT_MB),TALK_ID(10, UNIT_MB),
+                            TALK_ID(15, UNIT_MB),TALK_ID(32, UNIT_MB),
+                            TALK_ID(64, UNIT_MB),TALK_ID(75, UNIT_MB),
+                            TALK_ID(100, UNIT_MB),TALK_ID(128, UNIT_MB),
+                            TALK_ID(256, UNIT_MB),TALK_ID(512, UNIT_MB),
+                            TALK_ID(650, UNIT_MB),TALK_ID(700, UNIT_MB),
+                            TALK_ID(1024, UNIT_MB),TALK_ID(1536, UNIT_MB),
+                            TALK_ID(1792, UNIT_MB)),NULL),
+    CHOICE_ITEM(0,rec_channels,LANG_RECORDING_CHANNELS,"rec channels,stereo,mono",
+                0, NULL,2,LANG_CHANNEL_STEREO,LANG_CHANNEL_MONO),
+    CHOICE_ITEM(0,rec_split_type,LANG_SPLIT_TYPE, "rec split type,Split,Stop",
+                0, NULL,2,LANG_START_NEW_FILE,LANG_STOP_RECORDING),
+    CHOICE_ITEM(0,rec_split_method,LANG_SPLIT_MEASURE, "rec split method,Time,Filesize",
+                0, NULL,2,LANG_SPLIT_TIME,LANG_SPLIT_SIZE),
+    CHOICE_ITEM(0,rec_source,LANG_RECORDING_SOURCE, "rec source"
+#if defined(HAVE_SPDIF_IN) && defined(HAVE_FMRADIO_IN)
+                "mic,line,spdif,fmradio", 2,NULL, 4,
+#elif defined(HAVE_SPDIF_IN)
+                "mic,line,spdif", 2,NULL, 3,
+#elif defined(HAVE_FMRADIO_IN)
+                "mic,line,fmradio", 2,NULL, 3,
+#else
+                "mic,line",1,NULL, 2,
+#endif
+                LANG_RECORDING_SRC_MIC,LANG_RECORDING_SRC_LINE
+#if defined(HAVE_SPDIF_IN)
+                ,LANG_RECORDING_SRC_DIGITAL
+#endif
+#if defined(HAVE_FMRADIO_IN)
+                ,LANG_FM_RADIO
+#endif
+               ),
+    INT_ITEM(0,rec_prerecord_time,LANG_RECORD_PRERECORD_TIME,0,0,30,1,UNIT_SEC,
+             NULL, NULL, "prerecording time"),
+    STRINGCHOICE_ITEM(0,rec_directory,LANG_RECORD_DIRECTORY,
+                      "rec directory",0,2,
+                      _STR(REC_BASE_DIR,/*LANG_RECORD_CURRENT_DIR*/"Current Directory"),
+                      _TALKID(-1,LANG_RECORD_CURRENT_DIR),NULL),
+#ifdef CONFIG_BACKLIGHT
+    CHOICE_ITEM(0,cliplight,LANG_CLIP_LIGHT, "cliplight,off,main,both,remote",0,
+                NULL,4,LANG_OFF,LANG_MAIN_UNIT,LANG_REMOTE_MAIN,LANG_REMOTE_UNIT),
+#endif
+#if CONFIG_CODEC == MAS3587F
+    INT_ITEM(0,rec_mic_gain,LANG_RECORDING_GAIN,8,-128,128,1,UNIT_DB, NULL,
+             NULL, "rec mic gain"),
+    INT_ITEM(0,rec_left_gain,LANG_RECORDING_LEFT,8,0,15,1,UNIT_DB, NULL,
+             NULL, "rec left gain"),
+    INT_ITEM(0,rec_right_gain,LANG_RECORDING_RIGHT,8,0,15,1,UNIT_DB, NULL,
+             NULL, "rec right gain"),
+    STRINGCHOICE_ITEM(0,rec_frequency,LANG_RECORDING_FREQUENCY,"rec frequency",0,6,
+                      _STR("44.1kHz","48kHz","32kHz","22.05kHz","24kHz","16kHz"),
+                      _TALKID(TALK_ID(44, UNIT_KHZ),TALK_ID(48, UNIT_KHZ),
+                              TALK_ID(32, UNIT_KHZ),TALK_ID(22, UNIT_KHZ),
+                              TALK_ID(24, UNIT_KHZ),TALK_ID(16, UNIT_KHZ)),NULL),
+    INT_ITEM(0,rec_quality,LANG_RECORDING_QUALITY,5,0,7,1,UNIT_INT, NULL, 
+             NULL, "rec quality"),
+    BOOL_ITEM(0,rec_editable,LANG_RECORDING_EDITABLE, false,NULL, 
+              "editable recordings"),
+#endif /* CONFIG_CODEC == MAS3587F */
+#if CONFIG_CODEC == SWCODEC && defined(HAVE_RECORDING)
+#ifdef HAVE_UDA1380
+    INT_ITEM(0,rec_mic_gain,LANG_RECORDING_GAIN,16,-128,128,1,UNIT_DB, 
+             NULL, NULL, "rec mic gain"),
+#endif
+#ifdef HAVE_TLV320
+    /* TLV320 only has no mic boost or 20db mic boost */
+    INT_ITEM(0,rec_mic_gain,LANG_RECORDING_GAIN,0,0,20,20,UNIT_DB, 
+             NULL, NULL, "rec mic gain"),
+#endif
+    INT_ITEM(0,rec_left_gain,LANG_RECORDING_LEFT,0,-128,96,1,UNIT_DB,
+             NULL, NULL, "rec left gain"),
+    INT_ITEM(0,rec_right_gain,LANG_RECORDING_RIGHT,0,-128,96,1,UNIT_DB,
+             NULL, NULL, "rec right gain"),
+    
+#if 0 /* Till samplerates are added for SWCODEC */
+    STRINGCHOICE_ITEM(0,rec_frequency,LANG_RECORDING_FREQUENCY,"rec frequency",0,6,
+                    _STR("44.1kHz","48kHz","32kHz","22.05kHz","24kHz","16kHz"),
+                    _TALKID(TALK_ID(44, UNIT_KHZ),TALK_ID(48, UNIT_KHZ),
+                            TALK_ID(32, UNIT_KHZ),TALK_ID(22, UNIT_KHZ),
+                            TALK_ID(24, UNIT_KHZ),TALK_ID(16, UNIT_KHZ)),NULL),
+#else
+    STRINGCHOICE_ITEM(0,rec_frequency,LANG_RECORDING_FREQUENCY,
+                      "rec frequency",0,1,
+                    _STR("44.1kHz"), _TALKID(TALK_ID(44, UNIT_KHZ)),NULL),
+#endif
+
+#endif /* CONFIG_CODEC == SWCODEC && defined(HAVE_RECORDING) */
+    /* values for the trigger */
+    INT_ITEM(0,rec_start_thres,LANG_RECORD_START_THRESHOLD,-35,-87,100,1,
+             UNIT_INT, NULL, NULL, "trigger start threshold"),
+    INT_ITEM(0,rec_stop_thres,LANG_RECORD_STOP_THRESHOLD,-45,-87,100,1,
+             UNIT_INT, NULL, NULL, "trigger stop threshold"),
+    STRINGCHOICE_ITEM(0,rec_start_duration,LANG_RECORD_MIN_DURATION, 
+                      "trigger start duration",
+                      0,sizeof(trig_durations_strings)/
+                              sizeof(*trig_durations_strings),
+                      {.strings = (char **)trig_durations_strings},
+                      (int*)trig_durations_talks, NULL),
+    STRINGCHOICE_ITEM(0,rec_stop_postrec,LANG_RECORD_STOP_POSTREC,
+                      "trigger stop postrec",
+                      2,sizeof(trig_durations_strings)/
+                              sizeof(*trig_durations_strings),
+                      {.strings = (char **)trig_durations_strings},
+                      (int*)trig_durations_talks, NULL),
+    STRINGCHOICE_ITEM(0,rec_stop_gap,LANG_RECORD_STOP_GAP,
+                      "trigger min gap",
+                      1,sizeof(trig_durations_strings)/
+                              sizeof(*trig_durations_strings),
+                      {.strings = (char **)trig_durations_strings},
+                      (int*)trig_durations_talks, NULL),
+/*    CHOICE_ITEM(0,rec_trigger_mode,LANG_RECORD_TRIGGER_MODE,
+                "trigger mode,off,once,repeat", 0, NULL,3,
+                LANG_OFF,LANG_ONCE,LANG_REPEAT),*/
+#endif /* HAVE_RECORDING */
+#ifdef HAVE_SPDIF_POWER
+    BOOL_ITEM(0,spdif_enable,LANG_SPDIF_ENABLE, false,NULL, "spdif enable"),
+#endif
+    CHOICE_ITEM(0,next_folder,LANG_NEXT_FOLDER, "folder navigation,off,on,random",
+                0,NULL,3,LANG_OFF,LANG_ON,LANG_RANDOM),
+    BOOL_ITEM(0,runtimedb,LANG_RUNTIMEDB_ACTIVE, false,NULL, "gather runtime data"),
+
+#ifdef HAVE_DIRCACHE
+    /* dircache */
+    BOOL_ITEM(0,dircache,LANG_DIRCACHE_ENABLE, false,dircache_cb, "dircache"),
+    SYSTEM_ITEM(F_T_INT,dircache_size,0, NULL),
+#endif
+    
+    /* tagcache */
+#ifdef HAVE_TC_RAMCACHE
+    BOOL_ITEM(0,tagcache_ram,LANG_TAGCACHE_RAM, false,NULL, "tagcache_ram"),
+#endif
+    BOOL_ITEM(0,tagcache_autoupdate,LANG_TAGCACHE_AUTOUPDATE,
+              false,NULL, "tagcache_autoupdate"),
+    CHOICE_ITEM(0,default_codepage,LANG_DEFAULT_CODEPAGE,
+                "default codepage,iso8859-1,iso8859-7,iso8859-8,cp1251,"
+                "iso8859-11,cp1256,iso8859-9,iso8859-2,sjis,"
+                "gb2312,ksx1001,big5,utf-8,cp1256",
+                0, NULL,13,
+                LANG_CODEPAGE_LATIN1,LANG_CODEPAGE_GREEK,LANG_CODEPAGE_HEBREW,
+                LANG_CODEPAGE_CYRILLIC,LANG_CODEPAGE_THAI,LANG_CODEPAGE_ARABIC,
+                LANG_CODEPAGE_TURKISH,LANG_CODEPAGE_LATIN_EXTENDED,
+                LANG_CODEPAGE_JAPANESE,LANG_CODEPAGE_SIMPLIFIED,
+                LANG_CODEPAGE_KOREAN,LANG_CODEPAGE_TRADITIONAL,LANG_CODEPAGE_UTF8),
+    BOOL_ITEM(0,warnon_erase_dynplaylist,LANG_WARN_ERASEDYNPLAYLIST_MENU,
+              false,NULL,"warn when erasing dynamic playlist"),
+    
+#ifdef CONFIG_BACKLIGHT
+#ifdef HAS_BUTTON_HOLD
+    CHOICE_ITEM(0,backlight_on_button_hold,LANG_BACKLIGHT_ON_BUTTON_HOLD,
+                "backlight on button hold,normal,off,on",0,NULL,3,
+                LANG_BACKLIGHT_ON_BUTTON_HOLD_NORMAL, LANG_OFF,LANG_ON),
+#endif
+#ifdef HAVE_LCD_SLEEP
+    STRINGCHOICE_ITEM(0,lcd_sleep_after_backlight_off,
+                      LANG_LCD_SLEEP_AFTER_BACKLIGHT_OFF,
+                      "lcd sleep after backlight off",3,6,
+                      _STR("always","never","5","10","15","20","30","45","60","90"),
+                      _TALKID(LANG_ALWAYS,LANG_NEVER,TALK_ID(5, UNIT_SEC),
+                              TALK_ID(10, UNIT_SEC),TALK_ID(15, UNIT_SEC),
+                              TALK_ID(20, UNIT_SEC),TALK_ID(30, UNIT_SEC),
+                              TALK_ID(45, UNIT_SEC),TALK_ID(60, UNIT_SEC),
+                              TALK_ID(90, UNIT_SEC)),NULL),
+#endif
+#endif /* CONFIG_BACKLIGHT */
+
+#if CONFIG_CODEC == SWCODEC
+    /* replay gaim */
+    BOOL_ITEM(0,replaygain,LANG_REPLAYGAIN, false,NULL, "replaygain"),
+    CHOICE_ITEM(0,replaygain_type,LANG_REPLAYGAIN_MODE,
+                "replaygain type,track,album,track shuffle", 0,NULL,3,
+                LANG_TRACK_GAIN, LANG_ALBUM_GAIN,LANG_SHUFFLE_GAIN),
+    BOOL_ITEM(0,replaygain_noclip,LANG_REPLAYGAIN_NOCLIP, false,NULL,
+              "replaygain noclip"),
+    INT_ITEM(0,replaygain_preamp,LANG_REPLAYGAIN_PREAMP,0,-120,120,1,
+             UNIT_DB, NULL, NULL, "replaygain preamp"),
+    CHOICE_ITEM(0,beep,LANG_BEEP,"beep,off,weak,moderate,strong", 0,NULL,4,
+                LANG_OFF, LANG_WEAK,LANG_MODERATE,LANG_STRONG),
+    /* crossfade */
+    /* FIXME|FIXME all the cross* settings need checking FIXME|FIXME|FIXME*/
+    CHOICE_ITEM(0,crossfade,LANG_CROSSFADE_ENABLE,
+                "crossfade,off,shuffle,track skip,always", 0,NULL,4,
+                LANG_OFF, LANG_SHUFFLE,LANG_TRACKSKIP,LANG_ALWAYS),
+    INT_ITEM(0,crossfade_fade_in_delay,LANG_CROSSFADE_FADE_IN_DELAY,
+             0,0,7,1,UNIT_SEC, NULL, NULL, "crossfade fade in delay"),
+    INT_ITEM(0,crossfade_fade_out_delay,LANG_CROSSFADE_FADE_OUT_DELAY,
+             0,0,7,1,UNIT_SEC, NULL, NULL, "crossfade fade out delay"),
+    INT_ITEM(0,crossfade_fade_in_duration,LANG_CROSSFADE_FADE_IN_DURATION,
+             0,0,15,1,UNIT_SEC, NULL, NULL, "crossfade fade in duration"),
+    INT_ITEM(0,crossfade_fade_out_duration,LANG_CROSSFADE_FADE_OUT_DURATION,
+             0,0,15,1,UNIT_SEC, NULL, NULL, "crossfade fade out duration"),
+    CHOICE_ITEM(0,crossfade_fade_out_mixmode,LANG_CROSSFADE_FADE_OUT_MODE,
+                "crossfade fade out mode,crossfade,mix", 0,NULL,2,
+                LANG_CROSSFADE, LANG_MIX),
+    BOOL_ITEM(0,crossfeed,LANG_CROSSFEED, false,NULL, "crossfeed"),
+    INT_ITEM(0,crossfeed_direct_gain,LANG_CROSSFEED_DIRECT_GAIN,15,0,
+             60,5,UNIT_DB, NULL, crossfeed_format, "crossfeed direct gain"),
+    INT_ITEM(0,crossfeed_cross_gain,LANG_CROSSFEED_CROSS_GAIN,60,30,
+             120,5,UNIT_DB, NULL, crossfeed_format, "crossfeed cross gain"),
+    INT_ITEM(0,crossfeed_hf_attenuation,LANG_CROSSFEED_HF_ATTENUATION,
+             160,60,240,5,UNIT_DB, NULL, crossfeed_format, 
+             "crossfeed hf attenuation"),
+    INT_ITEM(0,crossfeed_hf_cutoff,LANG_CROSSFEED_HF_CUTOFF,700,500,
+             2000,100,UNIT_DB, NULL, NULL, "crossfeed hf cutoff"),
+#if 0
+    /* / FIXME|FIXME|FIXME|FIXME|FIXME|FIXME|FIXME|FIXME|FIXME|FIXME|FIXME| */
+    /* sw equalizer */
+    BOOL_ITEM(0,eq_enabled,LANG_EQUALIZER_ENABLED, false,NULL, "eq enabled"),
+    INT_ITEM(0,eq_precut,LANG_EQUALIZER_PRECUT,0,0,240,5,UNIT_DB,
+             NULL, NULL, "eq precut"),
+    /* 0..32768 Hz */
+    INT_ITEM(0,eq_band0_cutoff,LANG_EQUALIZER_BAND_CUTOFF,60,
+             EQ_CUTOFF_MIN,EQ_CUTOFF_MAX,EQ_CUTOFF_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 0 cutoff"),
+    INT_ITEM(0,eq_band1_cutoff,LANG_EQUALIZER_BAND_CUTOFF,200,
+             EQ_CUTOFF_MIN,EQ_CUTOFF_MAX,EQ_CUTOFF_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 1 cutoff"),
+    INT_ITEM(0,eq_band2_cutoff,LANG_EQUALIZER_BAND_CUTOFF,800,
+             EQ_CUTOFF_MIN,EQ_CUTOFF_MAX,EQ_CUTOFF_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 2 cutoff"),
+    INT_ITEM(0,eq_band3_cutoff,LANG_EQUALIZER_BAND_CUTOFF,4000,
+             EQ_CUTOFF_MIN,EQ_CUTOFF_MAX,EQ_CUTOFF_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 3 cutoff"),
+    INT_ITEM(0,eq_band4_cutoff,LANG_EQUALIZER_BAND_CUTOFF,12000,
+             EQ_CUTOFF_MIN,EQ_CUTOFF_MAX,EQ_CUTOFF_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 4 cutoff"),
+    /* 0..64 (or 0.0 to 6.4) */
+    INT_ITEM(0,eq_band0_q,LANG_EQUALIZER_BAND_Q,7,
+             EQ_Q_MIN,EQ_Q_MAX,EQ_Q_STEP,UNIT_DB, NULL, NULL,"eq band 0 q"),
+    INT_ITEM(0,eq_band1_q,LANG_EQUALIZER_BAND_Q,10,
+             EQ_Q_MIN,EQ_Q_MAX,EQ_Q_STEP,UNIT_DB, NULL, NULL,"eq band 1 q"),
+    INT_ITEM(0,eq_band2_q,LANG_EQUALIZER_BAND_Q,10,
+             EQ_Q_MIN,EQ_Q_MAX,EQ_Q_STEP,UNIT_DB, NULL, NULL,"eq band 2 q"),
+    INT_ITEM(0,eq_band3_q,LANG_EQUALIZER_BAND_Q,10,
+             EQ_Q_MIN,EQ_Q_MAX,EQ_Q_STEP,UNIT_DB, NULL, NULL,"eq band 3 q"),
+    INT_ITEM(0,eq_band4_q,LANG_EQUALIZER_BAND_Q,7,
+             EQ_Q_MIN,EQ_Q_MAX,EQ_Q_STEP,UNIT_DB, NULL, NULL,"eq band 4 q"),
+    /* -240..240 (or -24db to +24db) */
+    INT_ITEM(0,eq_band0_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_GAIN_MIN,EQ_GAIN_MAX,EQ_GAIN_STEP,UNIT_DB,
+             NULL, NULL,"eq band 0 gain"),
+    INT_ITEM(0,eq_band1_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_GAIN_MIN,EQ_GAIN_MAX,EQ_GAIN_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 1 gain"),
+    INT_ITEM(0,eq_band2_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_GAIN_MIN,EQ_GAIN_MAX,EQ_GAIN_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 2 gain"),
+    INT_ITEM(0,eq_band3_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_GAIN_MIN,EQ_GAIN_MAX,EQ_GAIN_STEP,UNIT_DB, 
+             NULL, NULL,"eq band 3 gain"),
+    INT_ITEM(0,eq_band4_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_GAIN_MIN,EQ_GAIN_MAX,EQ_GAIN_STEP,UNIT_DB,
+             NULL, NULL,"eq band 4 gain"),
+    BOOL_ITEM(0,dithering_enabled,LANG_DITHERING, false,NULL, "dithering enabled"),
+#endif
+#endif /* CONFIG_CODEC == SWCODEC */
+
+#ifdef HAVE_WM8758
+    /* hardware eq */
+    BOOL_ITEM(0,eq_hw_enabled,LANG_EQUALIZER_HARDWARE_ENABLED,
+              false,NULL, "eq hardware enabled"),
+    /* band 0 */
+    STRINGCHOICE_ITEM(0,eq_hw_band0_cutoff,LANG_EQUALIZER_BAND_CUTOFF,
+                      "eq hardware band 0 cutoff",1,4,
+                      _STR("80Hz","105Hz","135Hz","175Hz"),
+                      _TALKID(TALK_ID(80, UNIT_HERTZ),TALK_ID(105, UNIT_HERTZ),
+                              TALK_ID(135, UNIT_HERTZ),TALK_ID(175, UNIT_HERTZ)),
+                      NULL),
+    INT_ITEM(0,eq_band0_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_HW_GAIN_MIN,EQ_HW_GAIN_MAX,EQ_HW_GAIN_STEP,
+             UNIT_DB, NULL, NULL,"eq hardware band 0 gain"),
+    /* band 1 */
+    STRINGCHOICE_ITEM(0,eq_hw_band1_center,LANG_EQUALIZER_BAND_CENTER,
+                      "eq hardware band 1 center",1,4,
+                      _STR("230Hz","300Hz","385Hz","500Hz"),
+                      _TALKID(TALK_ID(230, UNIT_HERTZ),TALK_ID(300, UNIT_HERTZ),
+                              TALK_ID(385, UNIT_HERTZ),TALK_ID(500, UNIT_HERTZ)),
+                      NULL),
+    CHOICE_ITEM(0,eq_hw_band1_bandwidth,LANG_EQUALIZER_BANDWIDTH,
+                "eq hardware band 1 bandwidth,narrow,wide", 0,NULL,2,
+                LANG_EQUALIZER_HARDWARE_BANDWIDTH_NARROW,
+                LANG_EQUALIZER_HARDWARE_BANDWIDTH_WIDE),
+    INT_ITEM(0,eq_hw_band1_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_HW_GAIN_MIN,EQ_HW_GAIN_MAX,EQ_HW_GAIN_STEP,UNIT_DB,
+             NULL, NULL, "eq hardware band 1 gain"),
+    /* band 2 */
+    STRINGCHOICE_ITEM(0,eq_hw_band2_center,LANG_EQUALIZER_BAND_CENTER,
+                      "eq hardware band 2 center",1,4,
+                      _STR("650Hz","850Hz","1100Hz","1400Hz"),
+                      _TALKID(TALK_ID(650, UNIT_HERTZ),TALK_ID(850, UNIT_HERTZ),
+                              TALK_ID(1100, UNIT_HERTZ),
+                              TALK_ID(1400, UNIT_HERTZ)),NULL),
+    CHOICE_ITEM(0,eq_hw_band2_bandwidth,LANG_EQUALIZER_BANDWIDTH,
+                "eq hardware band 2 bandwidth,narrow,wide", 0,NULL,2,
+                LANG_EQUALIZER_HARDWARE_BANDWIDTH_NARROW,
+                LANG_EQUALIZER_HARDWARE_BANDWIDTH_WIDE),
+    INT_ITEM(F_LANG_HARDWARE,eq_hw_band2_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_HW_GAIN_MIN,EQ_HW_GAIN_MAX,EQ_HW_GAIN_STEP,UNIT_DB,
+             NULL, NULL, "eq hardware band 2 gain"),
+    /* band 3 */
+    STRINGCHOICE_ITEM(0,eq_hw_band3_center,LANG_EQUALIZER_BAND_CENTER,
+                      "eq hardware band 3 center",1,4,
+                      _STR("1800Hz","2400Hz","3200Hz","4100Hz"),
+                      _TALKID(TALK_ID(1800, UNIT_HERTZ),TALK_ID(2400, UNIT_HERTZ),
+                              TALK_ID(3200, UNIT_HERTZ),
+                              TALK_ID(4100, UNIT_HERTZ)),NULL),
+    CHOICE_ITEM(0,eq_hw_band3_bandwidth,LANG_EQUALIZER_BANDWIDTH
+            "eq hardware band 3 bandwidth,narrow,wide", 0,NULL,2,
+                LANG_EQUALIZER_HARDWARE_BANDWIDTH_NARROW,
+                LANG_EQUALIZER_HARDWARE_BANDWIDTH_WIDE),
+    INT_ITEM(F_LANG_HARDWARE,eq_hw_band3_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_HW_GAIN_MIN,EQ_HW_GAIN_MAX,EQ_HW_GAIN_STEP,
+             UNIT_DB, NULL, NULL,"eq hardware band 3 gain"),
+    /* band 4 */
+    STRINGCHOICE_ITEM(0,eq_hw_band4_cutoff,LANG_EQUALIZER_BAND_CUTOFF,
+                      "eq hardware band 4 cutoff",1,4,
+                      _STR("5300Hz","6900Hz","9000Hz","11700Hz"),
+                      _TALKID(TALK_ID(5300, UNIT_HERTZ),TALK_ID(6900, UNIT_HERTZ),
+                              TALK_ID(9000, UNIT_HERTZ),
+                              TALK_ID(11700, UNIT_HERTZ)),NULL),
+    INT_ITEM(0,eq_band4_gain,LANG_EQUALIZER_BAND_GAIN,0,
+             EQ_HW_GAIN_MIN,EQ_HW_GAIN_MAX,EQ_HW_GAIN_STEP,
+             UNIT_DB, NULL, NULL,"eq hardware band 4 gain"),
+#endif /* HAVE_WM8758 */
+
+/*    BOOL_ITEM(0,hold_lr_for_scroll_in_list,
+              LANG_HOLD_DIRECTION_FOR_SCROLL, true,NULL,
+              "hold_lr_for_scroll_in_list"),
+*/    CHOICE_ITEM(0,show_path_in_browser,LANG_SHOW_PATH,
+                "show path in browser,off,current directory,full path",0,NULL,3,
+                LANG_OFF,LANG_SHOW_PATH_CURRENT, LANG_SHOW_PATH_FULL),
+
+#ifdef HAVE_AGC
+    /* active gain control */
+    CHOICE_ITEM(0,rec_agc_preset_mic,LANG_RECORD_AGC_PRESET,
+                "agc mic preset", 1,NULL,6,
+                LANG_OFF,LANG_AGC_SAFETY, LANG_AGC_LIVE,
+                LANG_AGC_DJSET, LANG_AGC_MEDIUM, LANG_AGC_VOICE),
+    CHOICE_ITEM(0,rec_agc_preset_line,LANG_RECORD_AGC_PRESET,
+                "agc line preset", 1,NULL,6,
+                LANG_OFF,LANG_AGC_SAFETY, LANG_AGC_LIVE,
+                LANG_AGC_DJSET, LANG_AGC_MEDIUM, LANG_AGC_VOICE),
+    SYSTEM_ITEM(F_T_INT,rec_agc_maxgain_mic,104, NULL),
+    SYSTEM_ITEM(F_T_INT,rec_agc_maxgain_line,96, NULL),
+    STRINGCHOICE_ITEM(0,rec_agc_cliptime,LANG_RECORD_AGC_CLIPTIME,
+                      "agc cliptime",1,5,
+                      _STR("0.2s","0.4s","0.6s","0.8s","1s"),
+                      _TALKID(TALK_ID(200, UNIT_MS),TALK_ID(400, UNIT_MS),
+                              TALK_ID(600, UNIT_MS),TALK_ID(800, UNIT_MS),
+                              TALK_ID(1, UNIT_SEC)),NULL),
+#endif /* HAVE_AGC */
+
+#ifdef HAVE_REMOTE_LCD
+#ifdef HAS_REMOTE_BUTTON_HOLD
+    CHOICE_ITEM(0,remote_backlight_on_button_hold,LANG_BACKLIGHT_ON_BUTTON_HOLD,
+                      "remote backlight on button hold,normal,off,on",0,NULL,3,
+                  LANG_BACKLIGHT_ON_BUTTON_HOLD_NORMAL,LANG_OFF,LANG_ON),
+#endif
+#endif /* HAVE_REMOTE_LCD */
+
+    /* filename storage */
+#ifdef CONFIG_TUNER
+    STRING_ITEM(F_FILENAMEONLY|F_THEMESETTING,fmr_file,"fmr","",NULL),
+#endif
+    STRING_ITEM(F_FILENAMEONLY|F_THEMESETTING,font_file,"font","",NULL),
+    STRING_ITEM(F_FILENAMEONLY|F_THEMESETTING,wps_file,"wps","",NULL),
+#ifdef HAVE_REMOTE_LCD
+    STRING_ITEM(F_FILENAMEONLY|F_THEMESETTING,rwps_file,"rwps","",NULL),
+#endif
+    STRING_ITEM(F_FILENAMEONLY,lang_file,"lang","",NULL),
+#ifdef HAVE_LCD_COLOR
+    STRING_ITEM(F_FILENAMEONLY|F_THEMESETTING,backdrop_file,"backdrop","",NULL),
+#endif
+#ifdef HAVE_LCD_BITMAP
+    STRING_ITEM(F_FILENAMEONLY,kbd_file,"keyboard","",NULL),
+#endif
+#ifdef HAVE_HEADPHONE_DETECTION
+    CHOICE_ITEM(0,unplug_mode,LANG_UNPLUG,
+                "pause on headphone unplug,off,pause,resume", 0,NULL,3,
+                LANG_OFF,LANG_PAUSE, LANG_UNPLUG_RESUME),
+    INT_ITEM(0,unplug_rw,LANG_UNPLUG_RW,0,
+             0,15,1,UNIT_SEC, NULL, NULL,"rewind duration on pause"),
+    BOOL_ITEM(0,unplug_autoresume,
+              LANG_UNPLUG_DISABLE_AUTORESUME, false, NULL,
+              "disable autoresume if phones not present"),
+#endif
+    BOOL_ITEM(0,audioscrobbler,
+              LANG_AUDIOSCROBBLER, false, NULL,
+              "Last.fm Logging"),
+
+};
+const int nb_settings = sizeof(settings) / sizeof(*settings);
